/* Generated automatically by the program 'build/genpreds'
   from the machine description file '/startdir/src/gcc-14.1.0/gcc/config/avr/avr.md'.  */

#ifndef GCC_TM_CONSTRS_H
#define GCC_TM_CONSTRS_H

static inline bool
satisfies_constraint_m (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 54 "/startdir/src/gcc-14.1.0/gcc/common.md"
(memory_address_addr_space_p (GET_MODE (op), XEXP (op, 0),
						 MEM_ADDR_SPACE (op))));
}
static inline bool
satisfies_constraint_o (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 60 "/startdir/src/gcc-14.1.0/gcc/common.md"
(offsettable_nonstrict_memref_p (op)));
}
static inline bool
satisfies_constraint_V (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 69 "/startdir/src/gcc-14.1.0/gcc/common.md"
(memory_address_addr_space_p (GET_MODE (op), XEXP (op, 0),
						 MEM_ADDR_SPACE (op)))) && (!(
#line 71 "/startdir/src/gcc-14.1.0/gcc/common.md"
(offsettable_nonstrict_memref_p (op)))));
}
static inline bool
satisfies_constraint__l (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 78 "/startdir/src/gcc-14.1.0/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == PRE_DEC)) || (
#line 79 "/startdir/src/gcc-14.1.0/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == POST_DEC)));
}
static inline bool
satisfies_constraint__g (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 85 "/startdir/src/gcc-14.1.0/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == PRE_INC)) || (
#line 86 "/startdir/src/gcc-14.1.0/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == POST_INC)));
}
static inline bool
satisfies_constraint_p (rtx ARG_UNUSED (op))
{
  return 
#line 90 "/startdir/src/gcc-14.1.0/gcc/common.md"
(address_operand (op, VOIDmode));
}
static inline bool
satisfies_constraint_i (rtx op)
{
  return (
#line 94 "/startdir/src/gcc-14.1.0/gcc/common.md"
(CONSTANT_P (op))) && (
#line 95 "/startdir/src/gcc-14.1.0/gcc/common.md"
(!flag_pic || LEGITIMATE_PIC_OPERAND_P (op)));
}
static inline bool
satisfies_constraint_s (rtx op)
{
  return (
#line 99 "/startdir/src/gcc-14.1.0/gcc/common.md"
(CONSTANT_P (op))) && ((
#line 100 "/startdir/src/gcc-14.1.0/gcc/common.md"
(!CONST_SCALAR_INT_P (op))) && (
#line 101 "/startdir/src/gcc-14.1.0/gcc/common.md"
(!flag_pic || LEGITIMATE_PIC_OPERAND_P (op))));
}
static inline bool
satisfies_constraint_n (rtx op)
{
  return (
#line 105 "/startdir/src/gcc-14.1.0/gcc/common.md"
(CONST_SCALAR_INT_P (op))) && (
#line 106 "/startdir/src/gcc-14.1.0/gcc/common.md"
(!flag_pic || LEGITIMATE_PIC_OPERAND_P (op)));
}
static inline bool
satisfies_constraint_E (rtx op)
{
  return (
#line 110 "/startdir/src/gcc-14.1.0/gcc/common.md"
(CONST_DOUBLE_AS_FLOAT_P (op))) || (
#line 111 "/startdir/src/gcc-14.1.0/gcc/common.md"
(GET_CODE (op) == CONST_VECTOR
		    && GET_MODE_CLASS (GET_MODE (op)) == MODE_VECTOR_FLOAT));
}
static inline bool
satisfies_constraint_F (rtx op)
{
  return (
#line 117 "/startdir/src/gcc-14.1.0/gcc/common.md"
(CONST_DOUBLE_AS_FLOAT_P (op))) || (
#line 118 "/startdir/src/gcc-14.1.0/gcc/common.md"
(GET_CODE (op) == CONST_VECTOR
		    && GET_MODE_CLASS (GET_MODE (op)) == MODE_VECTOR_FLOAT));
}
static inline bool
satisfies_constraint_X (rtx ARG_UNUSED (op))
{
  return 
#line 123 "/startdir/src/gcc-14.1.0/gcc/common.md"
(true);
}
static inline bool
satisfies_constraint_I (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 59 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(ival >= 0 && ival <= 63));
}
static inline bool
satisfies_constraint_J (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 64 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(ival <= 0 && ival >= -63));
}
static inline bool
satisfies_constraint_K (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 69 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(ival == 2));
}
static inline bool
satisfies_constraint_L (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 74 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(ival == 0));
}
static inline bool
satisfies_constraint_M (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 79 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(ival >= 0 && ival <= 0xff));
}
static inline bool
satisfies_constraint_N (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 84 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(ival == -1));
}
static inline bool
satisfies_constraint_O (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 89 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(ival == 8 || ival == 16 || ival == 24));
}
static inline bool
satisfies_constraint_P (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 94 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(ival == 1));
}
static inline bool
satisfies_constraint_G (rtx op)
{
  return (GET_CODE (op) == CONST_DOUBLE) && (
#line 99 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(op == CONST0_RTX (SFmode)));
}
static inline bool
satisfies_constraint_Q (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 104 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(extra_constraint_Q (op)));
}
static inline bool
satisfies_constraint_Cm2 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 109 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(ival == -2));
}
static inline bool
satisfies_constraint_C03 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 114 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(ival == 3));
}
static inline bool
satisfies_constraint_C04 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 119 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(ival == 4));
}
static inline bool
satisfies_constraint_C05 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 124 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(ival == 5));
}
static inline bool
satisfies_constraint_C06 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 129 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(ival == 6));
}
static inline bool
satisfies_constraint_C07 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 134 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(ival == 7));
}
static inline bool
satisfies_constraint_C15 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 139 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(ival == 15));
}
static inline bool
satisfies_constraint_C23 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 144 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(ival == 23));
}
static inline bool
satisfies_constraint_C31 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 149 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(ival == 31));
}
static inline bool
satisfies_constraint_Ca1 (rtx op)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 154 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(avr_popcount_each_byte (op, 1, 1<<7)));
}
static inline bool
satisfies_constraint_Ca2 (rtx op)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 159 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(avr_popcount_each_byte (op, 2, (1<<0) | (1<<7) | (1<<8))));
}
static inline bool
satisfies_constraint_Ca3 (rtx op)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 164 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(avr_popcount_each_byte (op, 3, (1<<0) | (1<<7) | (1<<8))));
}
static inline bool
satisfies_constraint_Ca4 (rtx op)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 169 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(avr_popcount_each_byte (op, 4, (1<<0) | (1<<7) | (1<<8))));
}
static inline bool
satisfies_constraint_Co1 (rtx op)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 174 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(avr_popcount_each_byte (op, 1, 1<<1)));
}
static inline bool
satisfies_constraint_Co2 (rtx op)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 179 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(avr_popcount_each_byte (op, 2, (1<<0) | (1<<1) | (1<<8))));
}
static inline bool
satisfies_constraint_Co3 (rtx op)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 184 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(avr_popcount_each_byte (op, 3, (1<<0) | (1<<1) | (1<<8))));
}
static inline bool
satisfies_constraint_Co4 (rtx op)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 189 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(avr_popcount_each_byte (op, 4, (1<<0) | (1<<1) | (1<<8))));
}
static inline bool
satisfies_constraint_Cb2 (rtx op)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 194 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(single_one_operand (op, HImode)));
}
static inline bool
satisfies_constraint_Cb3 (rtx op)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 199 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(single_one_operand (op, PSImode)));
}
static inline bool
satisfies_constraint_Cb4 (rtx op)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 204 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(single_one_operand (op, SImode)));
}
static inline bool
satisfies_constraint_Cx2 (rtx op)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 209 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(avr_popcount_each_byte (op, 2, (1<<0) | (1<<8))));
}
static inline bool
satisfies_constraint_Cx3 (rtx op)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 214 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(avr_popcount_each_byte (op, 3, (1<<0) | (1<<8))));
}
static inline bool
satisfies_constraint_Cx4 (rtx op)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 219 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(avr_popcount_each_byte (op, 4, (1<<0) | (1<<8))));
}
static inline bool
satisfies_constraint_CX2 (rtx op)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 224 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(avr_xor_noclobber_dconst (op, 2)));
}
static inline bool
satisfies_constraint_CX3 (rtx op)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 229 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(avr_xor_noclobber_dconst (op, 3)));
}
static inline bool
satisfies_constraint_CX4 (rtx op)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 234 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(avr_xor_noclobber_dconst (op, 4)));
}
static inline bool
satisfies_constraint_Csp (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 239 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(IN_RANGE (ival, -11, 6)));
}
static inline bool
satisfies_constraint_Cxf (rtx op)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 244 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(avr_has_nibble_0xf (op)));
}
static inline bool
satisfies_constraint_C0f (rtx op)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 249 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(!avr_has_nibble_0xf (op)));
}
static inline bool
satisfies_constraint_Cn8 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 254 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(IN_RANGE (ival, -255, -1)));
}
static inline bool
satisfies_constraint_Ynn (rtx op)
{
  return GET_CODE (op) == CONST_FIXED;
}
static inline bool
satisfies_constraint_Y00 (rtx op)
{
  switch (GET_CODE (op))
    {
    case CONST_FIXED:
    case CONST_INT:
      break;
    default:
      return false;
    }
  return 
#line 267 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(op == CONST0_RTX (GET_MODE (op)));
}
static inline bool
satisfies_constraint_Y01 (rtx op)
{
  return ((GET_CODE (op) == CONST_FIXED) && (
#line 272 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(INTVAL (avr_to_int_mode (op)) == 1))) || (
#line 273 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(satisfies_constraint_P (op)));
}
static inline bool
satisfies_constraint_Ym1 (rtx op)
{
  return ((GET_CODE (op) == CONST_FIXED) && (
#line 278 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(INTVAL (avr_to_int_mode (op)) == -1))) || (
#line 279 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(satisfies_constraint_N (op)));
}
static inline bool
satisfies_constraint_Y02 (rtx op)
{
  return ((GET_CODE (op) == CONST_FIXED) && (
#line 284 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(INTVAL (avr_to_int_mode (op)) == 2))) || (
#line 285 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(satisfies_constraint_K (op)));
}
static inline bool
satisfies_constraint_Ym2 (rtx op)
{
  return ((GET_CODE (op) == CONST_FIXED) && (
#line 290 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(INTVAL (avr_to_int_mode (op)) == -2))) || (
#line 291 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(satisfies_constraint_Cm2 (op)));
}
static inline bool
satisfies_constraint_Yxx (rtx ARG_UNUSED (op))
{
  return 
#line 296 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(false);
}
static inline bool
satisfies_constraint_Yx2 (rtx op)
{
  return ((GET_CODE (op) == CONST_INT) || (GET_CODE (op) == CONST_FIXED)) && (
#line 302 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(!IN_RANGE (INTVAL (avr_to_int_mode (op)), -2, 2)));
}
static inline bool
satisfies_constraint_YIJ (rtx op)
{
  return (GET_CODE (op) == CONST_FIXED) && (
#line 309 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(IN_RANGE (INTVAL (avr_to_int_mode (op)), -63, 63)));
}
static inline bool
satisfies_constraint_Yil (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 314 "/startdir/src/gcc-14.1.0/gcc/config/avr/constraints.md"
(low_io_address_operand (XEXP (op, 0), Pmode)));
}
#endif /* tm-constrs.h */
